#include <iostream>
#include <vector>

void f(int x, int y = 7, std::vector<int> v = {}) {
	std::cout << "x = " << x << ", y = " << y
	          << ", v.size() = " << v.size() << '\n';
	// This is of course silly, but it demonstrates that a new vector is
	// really created each time the function is called without its third
	// argument. (Python fans might find this confusing.)
	v.push_back(1);
}

int main() {
	f(1);
	f(1, 2);
	f(1, 2, { 1, 2, 3 });

	for (int i = 0; i < 10; ++i) {
		f(0, 0);
	}
}
