#include <iostream>
#include <vector>

void f(const auto& /* unused */) {
	std::cout << "generic\n";
}

void f(int x) {
	std::cout << "int: " << x << '\n';
}

void f(const std::vector<int>& v) {
	std::cout << "vector<int>:";
	for (int x: v) {
		std::cout << ' ' << x;
	}
	std::cout << '\n';
}

int main() {
	f(3);    // only this one calls f(int)
	f('x');
	f(0.0);
	f(std::vector{ 1, 2, 3 });
	f(std::vector{ 3.14 });
}
