#include <iostream>

struct vector3d {
	double x, y, z;

	void print() const {
		std::cout << '(' << x << ", " << y << ", " << z << ")\n";
	}

	// notice the lack of symmetry
	vector3d operator+(const vector3d& other) const {
		return { x + other.x, y + other.y, z + other.z };
	}
};

int main() {
	vector3d u = { 1, 2, 3 };
	vector3d v = { 0, 0, 7 };
	(u + v).print();
}
